<template>
	<el-dialog :title="titleMap[mode]" v-model="visible" :width="500" destroy-on-close :close-on-click-modal="false" @closed="$emit('closed')">
		<el-form :model="form" :rules="rules" :disabled="mode=='show'" ref="dialogForm" label-width="100px" label-position="left">
			<el-form-item label="等级标题" prop="title">
				<el-input v-model="form.title" placeholder="等级标题" clearable />
			</el-form-item>
			<el-form-item label="等级标识" prop="name">
				<el-input v-model="form.name" placeholder="等级标识" clearable />
			</el-form-item>
			<el-form-item label="图标" prop="icon">
				<sc-upload v-model="form.icon" title="等级图标" />
			</el-form-item>
			<el-form-item label="描述" prop="remark">
				<el-input type="textarea" v-model="form.remark" placeholder="描述" clearable />
			</el-form-item>
			<el-form-item label="状态" prop="status">
				<el-select v-model="form.status" placeholder="请选择状态" clearable>
					<el-option v-for="(item, index) in [{label: '启用', value: 1}, {label: '禁用', value: 0}]" :key="index" :label="item.label" :value="item.value" />
				</el-select>
			</el-form-item>
			<el-form-item label="排序" prop="sort">
				<el-input-number v-model="form.sort" class="mx-4" :min="0" :max="100" controls-position="right" placeholder="排序" clearable />
			</el-form-item>
		</el-form>
		<template #footer>
			<el-button @click="visible=false" >取 消</el-button>
			<el-button v-if="mode!='show'" type="primary" :loading="isSaveing" @click="submit()">保 存</el-button>
		</template>
	</el-dialog>
</template>

<script>
export default {
	emits: ['success', 'closed'],
	data() {
		return {
			mode: "add",
			titleMap: {
				add: '新增等级',
				edit: '编辑等级',
				show: '查看'
			},
			visible: false,
			isSaveing: false,
			//表单数据
			form: { title: '', name: ''},
			//验证规则
			rules: {
				title: [{required: true, message: '请输入等级标题'}],
				name: [{required: true, message: '请输入等级标识'}],
			}
		}
	},
	mounted() {
	},
	methods: {
		//显示
		open(mode='add'){
			this.mode = mode;
			this.visible = true;
			return this
		},
		//表单提交方法
		submit(){
			this.$refs.dialogForm.validate(async (valid) => {
				if (valid) {
					this.isSaveing = true;
					var res = {};
					if(this.mode == 'add'){
						res = await this.$API.member.level.add.post(this.form);
					}else{
						res = await this.$API.member.level.edit.post(this.form);
					}

					this.isSaveing = false;
					if(res.code == 1){
						this.$emit('success', this.form, this.mode)
						this.visible = false;
						this.$message.success("操作成功")
					}else{
						this.$alert(res.message, "提示", {type: 'error'})
					}
				}else{
					return false;
				}
			})
		},
		//表单注入数据
		setData(data){
			this.form = data
		}
	}
}
</script>

<style>
</style>
